/*
 * kexec: Linux boots Linux
 *
 * Copyright (C) 2003,2004  Eric Biederman (ebiederm@xmission.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation (version 2 of the License).
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	.code32
	/* Make certain the special registers are in a sane state.
	 * The kernel should have done this but...
	 */
x86_setup_state:
	/* Don't modify any registers... */
	pushl	%eax

#if 0
	/* This code is only needed for old versions of the kexec kernel patch.
	 * While it is still a good idea doing this unconditionally breaks
	 * on older cpus that did not implemented cr4.
	 * So this code is disabled for now.  If this is revisited 
	 * I first need to detect cpuid support and then use cpuid 
	 * to conditionally change newer cpu registers.
	 */
	/* clear special bits in %cr4 */
	movl	%cr4, %eax
	andl	$0, %eax
	movl	%eax, %cr4
#endif	

	popl	%eax
	ret
